import globalPluginHandler
import os
import re 
from speech import getSynth
from tones import beep
class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	scriptCategory='eSpeakPatch'
	def __init__(self, *args, **kwargs):
		globalPluginHandler.GlobalPlugin.__init__(self, *args, **kwargs)
		self.activated=False
		if enabled:
			self.activate()
	def activate(self):
		synth=getSynth()
		try:
			self.original_function=synth._processText
		except AttributeError:
			return 1
		synth._processText=decorator(synth._processText)
		self.activated=True
	def deactivate(self):
		synth=getSynth()
		if not hasattr(synth, '_processText'):
			return 1
		synth._processText=self.original_function
		self.activated=False
	def script_turn(self, gesture):
		'''Активировать / деактивировать'''
		func=self.activate if not self.activated else self.deactivate
		if func():
			beep(1000, 300)
		else:
			beep(440 if self.activated else 220, 100)
	def terminate(self):
		if self.activated!=enabled:
			f=open(__file__, 'r+b')
			f.seek(-5, 2)
			f.write(b'True ' if self.activated else b'False')
			f.close()
		if self.activated:
			self.deactivate()
	__gestures={'kb:nvda+control+e': 'turn'}
def decorator(func):
	def wrapper(text):
		return func(fix_text(text))
	return wrapper
numbers_pattern=re.compile(r'(\d+(?:,\d+)*)*')
dots_pattern=re.compile(r'(?<=\d)\.(?=\d)')
try:
	f=open(os.path.join(os.path.dirname(__file__), 'digits.txt'), 'rb')
	digits=f.read().decode('1251').split('\r\n')
	f.close()
except Exception:
	digits=[]
def process_number(number):
	if (len(number)-1)//3>len(digits):
		return ' '.join(number)
	result=[]
	digit=-1
	while number:
		n=number[-3:].lstrip('0')
		number=number[:-3]
		if digit==0 and n and n[-1] in '12' and (len(n)<2 or n[-2]!='1'):
			end=n[-1]
			n=n[:-1]
			if n:
				n+='0'
			n+='одна ' if end=='1' else 'две '
		if n and digit>=0:
			n+=' '+digits[digit]
		if n:
			result.append(n)
		digit+=1
	return ' '.join(result[::-1])
def process_fraction(n):
	l=len(n)
	number=process_number(n)
	if not number:
		number='0'
	if l==1:
		number+='десятых'
	elif l==2:
		number+='сотых'
	else:
		offset=l%3
		digit=int((l-offset)/3)
		if digit<=len(digits):
			number+=('десяти' if offset==1 else 'сто' if offset==2 else '')+(digits[digit-1] if digit==1 else digits[digit-1][:-2])+'ных'
		else:
			number=' '.join(n)
	return number
def fix_numbers(number):
	number=[i for i in number[0].split(',') if i]
	if not number :
		return ''
	result=[]
	if len(number)>1:
		[result.append(process_number(i) if i[0]!='0' else i) for i in number[:-1]]
		result.append('и '+process_fraction(number[-1]))
	else:
		result=[process_number(number[0]) if number[0][0]!='0' else number[0]]
	return ' '.join(result)+' '
def debug_decorator(func):
	def wrapper(text):
		res=func(text)
		print(res)
		return res
	return wrapper
#@debug_decorator
def fix_text(text):
	text=re.sub(dots_pattern, ' точка ', text)
	return re.sub(numbers_pattern, fix_numbers, text).replace('ьи', 'ьйи')
enabled=False